/*

ͻ
                       OoClip   Version 1.5                           
             An Object Oriented Extension to Clipper 5.2X             
                 (c) 1996,1997 Nixil Hsiao, Universeen Co., Ltd.      
                 (c) 1991 Peter M. Freese, CyberSoft                  
ͼ

OoClip Version 1.5 -February 8,1997 By Nixil Hsiao,(uniseen@public3.bta.net.cn)
OoClip Version 1.0 -March  25 ,1996 By Nixil Hsiao,(uniseen@public3.bta.net.cn)
o:Clip Version 1.01-November 8,1991 By Peter M. Freese (CIS:72600,141)

                  Nixil Hsiao, Universeen Co., Ltd., Beijing 100094, P.R.China
                     Voice:    (8610)62633375, (8610)62581155
                     Pager:    (8610)68328800 call 11867
                  Internet:    uniseen@public3.bta.net.cn

**************************************************************************/

#ifndef _OOCLIP_CH
#define _OOCLIP_CH

#xcommand CREATE CLASS <name> [ALIAS <aliasName>] [ FROM <parent>] => ;
  CLASS <name> [ALIAS <aliasName>] [ FROM <parent> ]

#xcommand CLASS <name> [ALIAS <aliasName>] FROM <parent> => ;
  CLASS <name> [ALIAS <aliasName>] XFROM <parent>(.F.)

#xcommand CLASS <name> [ALIAS <aliasName>] [ XFROM <parent> ] => ;
FUNCTION <name>(lMakeClass);;
    STATIC hClass := 0, nPosition:=0;;
    LOCAL oNew, alias:=#<aliasName>;;
    if (EMPTY(alias),alias:=<"name">,);;
    if (lMakeClass==NIL,lMakeClass:=.T.,);;
    if (nPosition==0);;
        nPosition:=_oDefineClass(<"name">,alias,<{parent}>)

#xcommand VAR <var1> [,<varN>] => ;
        _oAddVar(nPosition,<"var1">) [; _oAddVar(nPosition,<"varN">)]

#xcommand METHOD <methodName> [,<*methodN*>] => ;
        _oAddMethod(nPosition,<"methodName">, alias+<"methodName">) [; METHOD <methodN>]

#xcommand METHOD <methodName> = <methodUDF> [,<*methodN*>] => ;
        _oAddMethod(nPosition,<"methodName">, <"methodUDF">) [; METHOD <methodN>]

#xcommand END CLASS => ENDCLASS

#xcommand ENDCLASS => ;
    end;;
    if  (lMakeClass) ;;
        if (hClass == 0,hClass := _oMakeClass(nPosition),);;
        oNew := __ClassIns(hClass);;
    else;;
        oNew :=nPosition;;
    end;;
RETURN oNew

#command METHOD FUNCTION <name> [;<*Any*>] => FUNCTION <name>() ;;
                LOCAL Self:=QSELF() [;<Any>]
#command METHOD FUNCTION <name> ([<list,...>]) [;<*Any*>] => FUNCTION <name>([<list>]) ;;
                LOCAL Self:=QSELF() [;<Any>]

#xtranslate :: => self:

// Class TBrowse edit mode
#define  TB_READONLY     0             // ֻ
#define  TB_NOAPPEND     1             // ޸ݣ׷¼¼
#define  TB_AUTOAPPEND   2             // ޸ݣԶ׷¼¼

#endif
