#include "ooclip.ch"

// set proc to opendbf

PROC main()

LOCAL o2                         // init the dbf object variable
Local nStart, nElapse_OOP,x

public handle:={}               // this array stores the class handle, and original variable count

// aINdex := if(aIndex # NIL,aIndex,NIL)

//  this returns the object with the database & index open, in specified mode, new
// o2 := oDbf():New( cAlias, cDbf, aIndex, lShared ) 

o2 := oDbf():New( "MyAlias", "Cr_Arlst", "Ss_No", .f. ) // exclusive

cls
? "there were originally "+ ltrim(str( o2:nOffset )) +" variables in the class."
? "there are now "+ ltrim(str(  len(o2) )) +" variables, including fields from dbf."
inkey(0)
cls

// o2:flock()              // lock the file
delete for recno() > 10         // just so we don't get a huge file later...
pack
// o2:unlock()             // duh...
o2:kill()               // close the work area

// o2 := oDbf():New( "MyAlias", "Cr_Arlst", "Ss_No", .t. )      // shared
   o2 := oDbf():New( "MyAlias", "Cr_Arlst", "Ss_No" )           // shared

******************************************************************
// test 1. data movement, record creation, field changes
//

o2:Gotop()                                    // go to top of file
o2:read()       // read current record to show data?

for x = 1 to 100    // ********************* add 100 records
    o2:add()        // add a new record
    o2:write()      // populate the record fields
next

o2:Gotop()                                    // go to top of file
o2:browse()                                   // generic dbf browse

o2:ss_no := "123-12-1234"                     // change the first records ss_no field
o2:write()                                    // save the change

o2:browse()                                     // so you can see the changes

******************************************************************
// test 2. data movement, timing of data movement
//

nStart  := seconds()

o2:Gotop()                                    // go to top of file
Do While !o2:Eof()
   o2:Skip(1)                                 // user defined skip value
Enddo

nElapse_OOP := seconds() - nStart

CLS
? "It took "+ ltrim(str(nElapse_OOP)) +;
  " seconds to skip process "+ ltrim(str(reccount())) +" records."
inkey(0)

setmode(25,80)

RETURN

